default:
  image: 
    name: registry.gitlab.com/zachariah.miller31/go-task-experiments/builder-image:latest
    entrypoint: [""]

stages:
  - build
  - test
  - publish

variables:
  GO_PROJECT_PATH: "task"
  APP_NAME: "ci-task-generator"

build:
  script:
    - /usr/bin/go build -o ./bin/app
  artifacts:
    paths:
      - ./bin/app


test:
  script:
    - /usr/bin/go test -coverprofile=coverage.out -v ./...
  artifacts:
    paths:
      - coverage.out
    

publish:
  needs:
    - job: build
      artifacts: true
    - job: test
  image: docker.io/fedora:latest
  script:
    - 'curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --upload-file ./bin/app "${CI_API_V4_URL}/projects/$CI_PROJECT_ID/packages/generic/$GO_PROJECT_PATH/$CI_COMMIT_REF_NAME/app"'

download_and_dockerize:
  variables:
  before_script:
    - buildah login -u $CI_REGISTRY_USER -p $CI_JOB_TOKEN $CI_REGISTRY
  image: quay.io/buildah/stable
  needs:
    - job: publish
  script:
    - echo "Verify the package can be downloaded"
    - 'curl --header "JOB-TOKEN: $CI_JOB_TOKEN" --output "./app" ${CI_API_V4_URL}/projects/$CI_PROJECT_ID/packages/generic/$GO_PROJECT_PATH/$CI_COMMIT_REF_NAME/app'
    - echo "pull rootfs to build scratch image"
    - mkdir -p /mnt/rootfs
    - yum install --installroot /mnt/rootfs --releasever 39 --setopt install_weak_deps=false --nodocs -y coreutils-single glibc-minimal-langpack bash go-task openssl; yum clean all; rm -rf /mnt/rootfs/var/cache/*
    - baseimage=$(buildah from scratch)
    - echo $baseimage 
    - mntbase=$(buildah mount $baseimage)
    - buildah add $baseimage "/mnt/rootfs"
    - mv $mntbase/usr/bin/go-task $mntbase/usr/bin/task
    #- cp -r ./app $mntbase/
    - buildah config --entrypoint "/bin/bash" $baseimage
    - buildah config --author "Zachariah Miller" $baseimage 
    - buildah config --arch $ARCH $baseimage
    - buildah config --label Name=$IMAGENAME $baseimage 
    - buildah commit $baseimage $IMAGENAME:${DEPLOYVER}-$ARCH
    - buildah images|grep $IMAGENAME|awk '{print $3}' > imagehash.txt
    - buildah unmount $baseimage
    - buildah rm $baseimage
    - export IMAGEHASH=$(cat imagehash.txt)
    - buildah push $IMAGEHASH $CI_REGISTRY_IMAGE/$IMAGENAME:${DEPLOYVER}

